import { PropertyValueOption } from '../../API';
import { CRUDService, ICrudService } from '../../core';
export declare class PropertyValueOptionService extends CRUDService<PropertyValueOption> {
    protected hasOneModels: ICrudService<PropertyValueOption>['hasOneModels'];
    get create(): (input: Partial<Record<never, import("../../../..").ModelWithId[]> & Record<import("../../core").HasOneRelationsOf<PropertyValueOption>, import("../../../..").ModelWithId>> & Omit<import("../../API").CreatePropertyValueOption, import("../../core").HasOneRelationsOf<PropertyValueOption>>, options?: import("../../core").MutationOptionsWithoutMutation<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../../API").PropertyValueOptionCreateOneMutation, import("../../API").Exact<{
        input: import("../../API").CreatePropertyValueOption;
    }>>>) => Promise<{
        __typename?: "PropertyValueOption";
        id: string;
        objectSource?: string;
        organizationID: string;
        propertyOptionID?: string;
        propertyValueMapID?: string;
        value: string;
        dynamicScoreValue?: {
            __typename?: "DynamicScoreValue";
            id: string;
            name: string;
        };
        propertyOption?: {
            __typename?: "PropertyOption";
            id: string;
            name?: string;
            objectSource: import("../../API").SourceOfData;
            objectType: import("../../API").PropertyType;
            propertyMapID?: string;
        };
        valueMap?: {
            __typename?: "PropertyValueMap";
            id: string;
            value: string;
        };
    }>;
    get useCreate(): (options?: import("../../core").CacheUpdateOptions<import("../../core").ServiceMutationHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../../API").PropertyValueOptionCreateOneMutation, import("../../API").Exact<{
        input: import("../../API").CreatePropertyValueOption;
    }>>>>) => [(payload: import("../../core").InputAndRelations<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../../API").PropertyValueOptionCreateOneMutation, import("../../API").Exact<{
        input: import("../../API").CreatePropertyValueOption;
    }>>, PropertyValueOption>) => Promise<{
        __typename?: "PropertyValueOption";
        id: string;
        objectSource?: string;
        organizationID: string;
        propertyOptionID?: string;
        propertyValueMapID?: string;
        value: string;
        dynamicScoreValue?: {
            __typename?: "DynamicScoreValue";
            id: string;
            name: string;
        };
        propertyOption?: {
            __typename?: "PropertyOption";
            id: string;
            name?: string;
            objectSource: import("../../API").SourceOfData;
            objectType: import("../../API").PropertyType;
            propertyMapID?: string;
        };
        valueMap?: {
            __typename?: "PropertyValueMap";
            id: string;
            value: string;
        };
    }>, import("@apollo/client").MutationResult<{
        createOne: import("../../../..").ModelWithId;
    }>];
    get update(): (input: Partial<Record<never, import("../../../..").ModelWithId[]> & Record<import("../../core").HasOneRelationsOf<PropertyValueOption>, import("../../../..").ModelWithId>> & Omit<import("../../API").UpdatePropertyValueOption, import("../../core").HasOneRelationsOf<PropertyValueOption>> & {
        id: string;
    }, options?: import("../../core").MutationOptionsWithoutMutation<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../../API").UpdateOnePropertyValueOptionMutation, import("../../API").Exact<{
        input: import("../../API").UpdateOnePropertyValueOptionInput;
    }>>>) => Promise<{
        __typename?: "PropertyValueOption";
        id: string;
        objectSource?: string;
        organizationID: string;
        propertyOptionID?: string;
        propertyValueMapID?: string;
        value: string;
        dynamicScoreValue?: {
            __typename?: "DynamicScoreValue";
            id: string;
            name: string;
        };
        propertyOption?: {
            __typename?: "PropertyOption";
            id: string;
            name?: string;
            objectSource: import("../../API").SourceOfData;
            objectType: import("../../API").PropertyType;
            propertyMapID?: string;
        };
        valueMap?: {
            __typename?: "PropertyValueMap";
            id: string;
            value: string;
        };
    }>;
    get useUpdate(): (mainOptions?: import("../../core").CacheUpdateOptions<import("../../core").ServiceMutationHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../../API").UpdateOnePropertyValueOptionMutation, import("../../API").Exact<{
        input: import("../../API").UpdateOnePropertyValueOptionInput;
    }>>>>) => [({ id, ...input }: Partial<Record<never, import("../../../..").ModelWithId[]> & Record<import("../../core").HasOneRelationsOf<PropertyValueOption>, import("../../../..").ModelWithId>> & import("../../API").UpdatePropertyValueOption & {
        id: string;
    }, options?: import("../../core").CacheUpdateOptions<import("../../core").ServiceMutationHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../../API").UpdateOnePropertyValueOptionMutation, import("../../API").Exact<{
        input: import("../../API").UpdateOnePropertyValueOptionInput;
    }>>>>) => Promise<Record<string, unknown>>, import("@apollo/client").MutationResult<{
        updateOne: Record<string, unknown>;
    }>];
    get delete(): (id: string, options?: import("../../core").MutationOptionsWithoutMutation<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../../API").PropertyValueOptionDeleteOneMutation, import("../../API").Exact<{
        input: import("../../API").DeleteOnePropertyValueOptionInput;
    }>>>) => Promise<{
        __typename?: "PropertyValueOptionDeleteResponse";
        id?: string;
    }>;
    get get(): (id: string, options?: Omit<import("@apollo/client").QueryOptions<import("../../API").Exact<{
        id: string;
    }>, import("../../API").PropertyValueOptionGetQuery>, "query">) => Promise<{
        __typename?: "PropertyValueOption";
        id: string;
        objectSource?: string;
        organizationID: string;
        propertyOptionID?: string;
        propertyValueMapID?: string;
        value: string;
        dynamicScoreValue?: {
            __typename?: "DynamicScoreValue";
            id: string;
            name: string;
        };
        propertyOption?: {
            __typename?: "PropertyOption";
            id: string;
            name?: string;
            objectSource: import("../../API").SourceOfData;
            objectType: import("../../API").PropertyType;
            propertyMapID?: string;
        };
        valueMap?: {
            __typename?: "PropertyValueMap";
            id: string;
            value: string;
        };
    }>;
    get useGet(): (options: import("../../core").ServiceQueryHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../../API").PropertyValueOptionGetQuery, import("../../API").Exact<{
        id: string;
    }>>>) => {
        isLoading: boolean;
        isRefetching: boolean;
        hasMore: any;
        refetching: boolean;
        client: import("@apollo/client").ApolloClient<any>;
        observable: import("@apollo/client").ObservableQuery<import("../../API").PropertyValueOptionGetQuery, import("../../API").Exact<{
            id: string;
        }>>;
        data: import("../../API").PropertyValueOptionGetQuery;
        previousData?: import("../../API").PropertyValueOptionGetQuery;
        error?: import("@apollo/client").ApolloError;
        errors?: readonly import("graphql").GraphQLFormattedError[];
        loading: boolean;
        networkStatus: import("@apollo/client").NetworkStatus;
        called: boolean;
        startPolling: (pollInterval: number) => void;
        stopPolling: () => void;
        subscribeToMore: <TSubscriptionData = import("../../API").PropertyValueOptionGetQuery, TSubscriptionVariables extends import("@apollo/client").OperationVariables = import("../../API").Exact<{
            id: string;
        }>>(options: import("@apollo/client").SubscribeToMoreOptions<import("../../API").PropertyValueOptionGetQuery, TSubscriptionVariables, TSubscriptionData>) => () => void;
        updateQuery: <TVars extends import("@apollo/client").OperationVariables = import("../../API").Exact<{
            id: string;
        }>>(mapFn: (previousQueryResult: import("../../API").PropertyValueOptionGetQuery, options: Pick<import("@apollo/client").WatchQueryOptions<TVars, import("../../API").PropertyValueOptionGetQuery>, "variables">) => import("../../API").PropertyValueOptionGetQuery) => void;
        refetch: (variables?: Partial<import("../../API").Exact<{
            id: string;
        }>>) => Promise<import("@apollo/client").ApolloQueryResult<import("../../API").PropertyValueOptionGetQuery>>;
        reobserve: (newOptions?: Partial<import("@apollo/client").WatchQueryOptions<import("../../API").Exact<{
            id: string;
        }>, import("../../API").PropertyValueOptionGetQuery>>, newNetworkStatus?: import("@apollo/client").NetworkStatus) => Promise<import("@apollo/client").ApolloQueryResult<import("../../API").PropertyValueOptionGetQuery>>;
        variables: import("../../API").Exact<{
            id: string;
        }>;
        fetchMore: <TFetchData = import("../../API").PropertyValueOptionGetQuery, TFetchVars extends import("@apollo/client").OperationVariables = import("../../API").Exact<{
            id: string;
        }>>(fetchMoreOptions: import("@apollo/client").FetchMoreQueryOptions<TFetchVars, TFetchData> & {
            updateQuery?: (previousQueryResult: import("../../API").PropertyValueOptionGetQuery, options: {
                fetchMoreResult: TFetchData;
                variables: TFetchVars;
            }) => import("../../API").PropertyValueOptionGetQuery;
        }) => Promise<import("@apollo/client").ApolloQueryResult<TFetchData>>;
    };
    get list(): (input: import("../../API").Exact<{
        filter?: import("../../API").PropertyValueOptionFilter;
        sorting?: import("../../API").PropertyValueOptionSort | import("../../API").PropertyValueOptionSort[];
        paging?: import("../../API").CursorPaging;
    }>, options?: import("../../core").ServiceQueryOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../../API").PropertyValueOptionsListQuery, import("../../API").Exact<{
        filter?: import("../../API").PropertyValueOptionFilter;
        sorting?: import("../../API").PropertyValueOptionSort | import("../../API").PropertyValueOptionSort[];
        paging?: import("../../API").CursorPaging;
    }>>>) => Promise<{
        __typename?: "PropertyValueOptionConnection";
        totalCount: number;
        edges: {
            __typename?: "PropertyValueOptionEdge";
            cursor: any;
            node: {
                __typename?: "PropertyValueOption";
                id: string;
                objectSource?: string;
                organizationID: string;
                propertyOptionID?: string;
                propertyValueMapID?: string;
                value: string;
                dynamicScoreValue?: {
                    __typename?: "DynamicScoreValue";
                    id: string;
                    name: string;
                };
                propertyOption?: {
                    __typename?: "PropertyOption";
                    id: string;
                    name?: string;
                    objectSource: import("../../API").SourceOfData;
                    objectType: import("../../API").PropertyType;
                    propertyMapID?: string;
                };
                valueMap?: {
                    __typename?: "PropertyValueMap";
                    id: string;
                    value: string;
                };
            };
        }[];
        pageInfo: {
            __typename?: "PageInfo";
            endCursor?: any;
            hasNextPage?: boolean;
            hasPreviousPage?: boolean;
            startCursor?: any;
        };
    }>;
    get useList(): (options: import("../../core").CacheUpdateOptions<import("../../core").ServiceQueryHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../../API").PropertyValueOptionsListQuery, import("../../API").Exact<{
        filter?: import("../../API").PropertyValueOptionFilter;
        sorting?: import("../../API").PropertyValueOptionSort | import("../../API").PropertyValueOptionSort[];
        paging?: import("../../API").CursorPaging;
    }>>>>) => {
        isLoading: boolean;
        isRefetching: boolean;
        hasMore: any;
        refetching: boolean;
        client: import("@apollo/client").ApolloClient<any>;
        observable: import("@apollo/client").ObservableQuery<import("../../API").PropertyValueOptionsListQuery, import("../../API").Exact<{
            filter?: import("../../API").PropertyValueOptionFilter;
            sorting?: import("../../API").PropertyValueOptionSort | import("../../API").PropertyValueOptionSort[];
            paging?: import("../../API").CursorPaging;
        }>>;
        data: import("../../API").PropertyValueOptionsListQuery;
        previousData?: import("../../API").PropertyValueOptionsListQuery;
        error?: import("@apollo/client").ApolloError;
        errors?: readonly import("graphql").GraphQLFormattedError[];
        loading: boolean;
        networkStatus: import("@apollo/client").NetworkStatus;
        called: boolean;
        startPolling: (pollInterval: number) => void;
        stopPolling: () => void;
        subscribeToMore: <TSubscriptionData = import("../../API").PropertyValueOptionsListQuery, TSubscriptionVariables extends import("@apollo/client").OperationVariables = import("../../API").Exact<{
            filter?: import("../../API").PropertyValueOptionFilter;
            sorting?: import("../../API").PropertyValueOptionSort | import("../../API").PropertyValueOptionSort[];
            paging?: import("../../API").CursorPaging;
        }>>(options: import("@apollo/client").SubscribeToMoreOptions<import("../../API").PropertyValueOptionsListQuery, TSubscriptionVariables, TSubscriptionData>) => () => void;
        updateQuery: <TVars extends import("@apollo/client").OperationVariables = import("../../API").Exact<{
            filter?: import("../../API").PropertyValueOptionFilter;
            sorting?: import("../../API").PropertyValueOptionSort | import("../../API").PropertyValueOptionSort[];
            paging?: import("../../API").CursorPaging;
        }>>(mapFn: (previousQueryResult: import("../../API").PropertyValueOptionsListQuery, options: Pick<import("@apollo/client").WatchQueryOptions<TVars, import("../../API").PropertyValueOptionsListQuery>, "variables">) => import("../../API").PropertyValueOptionsListQuery) => void;
        refetch: (variables?: Partial<import("../../API").Exact<{
            filter?: import("../../API").PropertyValueOptionFilter;
            sorting?: import("../../API").PropertyValueOptionSort | import("../../API").PropertyValueOptionSort[];
            paging?: import("../../API").CursorPaging;
        }>>) => Promise<import("@apollo/client").ApolloQueryResult<import("../../API").PropertyValueOptionsListQuery>>;
        reobserve: (newOptions?: Partial<import("@apollo/client").WatchQueryOptions<import("../../API").Exact<{
            filter?: import("../../API").PropertyValueOptionFilter;
            sorting?: import("../../API").PropertyValueOptionSort | import("../../API").PropertyValueOptionSort[];
            paging?: import("../../API").CursorPaging;
        }>, import("../../API").PropertyValueOptionsListQuery>>, newNetworkStatus?: import("@apollo/client").NetworkStatus) => Promise<import("@apollo/client").ApolloQueryResult<import("../../API").PropertyValueOptionsListQuery>>;
        variables: import("../../API").Exact<{
            filter?: import("../../API").PropertyValueOptionFilter;
            sorting?: import("../../API").PropertyValueOptionSort | import("../../API").PropertyValueOptionSort[];
            paging?: import("../../API").CursorPaging;
        }>;
        fetchMore: <TFetchData = import("../../API").PropertyValueOptionsListQuery, TFetchVars extends import("@apollo/client").OperationVariables = import("../../API").Exact<{
            filter?: import("../../API").PropertyValueOptionFilter;
            sorting?: import("../../API").PropertyValueOptionSort | import("../../API").PropertyValueOptionSort[];
            paging?: import("../../API").CursorPaging;
        }>>(fetchMoreOptions: import("@apollo/client").FetchMoreQueryOptions<TFetchVars, TFetchData> & {
            updateQuery?: (previousQueryResult: import("../../API").PropertyValueOptionsListQuery, options: {
                fetchMoreResult: TFetchData;
                variables: TFetchVars;
            }) => import("../../API").PropertyValueOptionsListQuery;
        }) => Promise<import("@apollo/client").ApolloQueryResult<TFetchData>>;
    };
}
